library ssddrtdb_flutter;

import 'dart:convert';

import 'package:ssddrtdbx_flutter/path_gen.dart';
import 'package:ssddrtdbx_flutter/shelf.dart';
import 'package:web_socket_channel/web_socket_channel.dart';

import 'datasnapshot.dart';

typedef ValueChanged<T> = void Function(T value);

/// A Calculator.
class SSDD {
  final String _uri;
  String _childrenHolder = "", _childrenHolder2 = "";
  var _channel, _vfier = "";
  List<Object> snapshots = [];
  final String _ssddKeepAlive = "ssdd-keep-alive",
      _id = "id",
      _single = "single",
      _nsv = "nsv",
      _sv = "sv",
      _message = "message",
      _path = "path";

  ValueChanged<List<Object>>? _datasnapshotsx;
  ValueChanged<Object>? _singleV;

  SSDD(this._uri) {
    init();
  }

  void init() {
    _channel = WebSocketChannel.connect(Uri.parse(_uri));
    _channel.stream.listen((msg) {
      if (msg != _vfier) {
        _vfier = msg;
        if (!(msg.toString() == _ssddKeepAlive)) {
          var object = json.decode(msg.toString());
          if (object[_id] == _nsv) {
            List<dynamic> array = json.decode(object[_message]);
            for (int i = 0; i < array.length; i++) {
              try {
                snapshots.add(jsonEncode(array[i]));
              } catch (e) {}
              if (i == (array.length - 1)) {
                _datasnapshotsx!(snapshots);
              }
            }
          } else {
            _singleV!(object[_message]);
          }
        }
      }
    });
  }

  void setValue(Object value) {
    String _cc;
    if (_childrenHolder != "") {
      _cc = _childrenHolder;
    } else {
      _cc = _childrenHolder2;
    }
    _childrenHolder = "";
    _childrenHolder2 = _cc;
    Map<String, Object> obj = {};
    obj[_id] = _sv;
    obj[_message] = value;
    obj[_path] = _cc;
    _channel.sink.add(jsonEncode(obj));
    // channel.sink.close(status.goingAway);
  }

  SSDD c(String path) {
    List<String>? tmpSplitContainer;
    if (path.contains("/")) {
      tmpSplitContainer = path.split("/");
      String tmpPath = "";
      for (String x in tmpSplitContainer) {
        tmpPath = tmpPath + x + "/";
      }
      _childrenHolder = tmpPath;
    } else {
      _childrenHolder = path;
    }
    return this;
  }

  SSDD push() {
    _childrenHolder =
        "$_childrenHolder/${PathGen.generatePushChildName(DateTime.now().millisecondsSinceEpoch)}";
    // _children.add(PathGen.generatePushChildName(DateTime.now().millisecondsSinceEpoch));
    return this;
  }

  void onValueChange(ValueChanged<Object> _singleV) {
    this._singleV = _singleV;
    try {
      String _cc;
      if (_childrenHolder != "") {
        _cc = _childrenHolder;
      } else {
        _cc = _childrenHolder2;
      }
      _childrenHolder = "";
      _childrenHolder2 = _cc;
      Map<String, Object> obj = {};
      obj[_id] = _single;
      obj[_path] = _cc;
      _channel.sink.add(jsonEncode(obj));
    } catch (e) {
      print("An error occured 08 $e");
    }
  }

  void onDataChange(ValueChanged<List<Object>> _datasnapshotsx) {
    this._datasnapshotsx = _datasnapshotsx;
    try {
      String _cc;
      if (_childrenHolder != "") {
        _cc = _childrenHolder;
      } else {
        _cc = _childrenHolder2;
      }
      _childrenHolder = "";
      _childrenHolder2 = _cc;
      Map<String, Object> obj = {};
      obj[_id] = _nsv;
      obj[_path] = _cc;
      _channel.sink.add(jsonEncode(obj));
    } catch (e) {
      print("An error occured 07 $e");
    }
  }
}
